if(!$ddevguiexe)
{
	exec("./newEventsDlg.gui");
	exec("./NewEventsAdvancedGui.gui");
}

exec("config/client/eventfavs.cs");

$highestrow = 0;
$realhigh = 0;

function addcolor(%row,%okay)
{
	NewEventScroll.scrolltotop();showallfeatures();

	if(%row > $highestrow)
		$highestrow = %row;


	%color = "255 0 0 100";
	if(%okay) 
		%color = "0 255 0 100";

	if(isObject($rowcolors[%row]))
	{
		$rowcolors[%row].color = %color;
		return;
	}	

        $rowcolors[%row] = new GuiSwatchCtrl(%row) {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "0 " SPC %row*30;
            extent = "1200 30";
            minExtent = "8 2";
            visible = "1";
            color = %color;
         };

        %b = new GuiSwatchCtrl() {
            profile = "GuiDefaultProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "0 29";
            extent = "1200 1";
            minExtent = "1 1";
            visible = "1";
            color = "0 0 0 255";
         };

	$rowcolors[%row].add(%b);
	NewEventScroll.add($rowcolors[%row]);

	for(%a=0;%a<$highestrow;%a++)
		$rowcolors[%a].position = "0 " SPC %a*30;
}

function clearcolorrows()
{
	if(isObject(DDEventsColor))
		DDEventsColor.delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowcolors[%a]))
			$rowcolors[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowinputbutton[%a]))
			$rowinputbutton[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowtargetbutton[%a]))
			$rowtargetbutton[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowdelaybox[%a]))
			$rowdelaybox[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowoutputevent[%a]))
			$rowoutputevent[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowcheckbox[%a]))
			$rowcheckbox[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rownamebox[%a]))
			$rownamebox[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowremove[%a]))
			$rowremove[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowcopy[%a]))
			$rowcopy[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rownum[%a]))
			$rownum[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowup[%a]))
			$rowup[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowdown[%a]))
			$rowdown[%a].delete();
	for(%a=0;%a<$highestrow+1;%a++)
	{
		for(%b=0;%b<10;%b++)
		{
			if(isObject($rowparameter[%a,%b]))
				$rowparameter[%a,%b].delete();
		}
	}
	for(%a=0;%a<$highestrow+1;%a++)
	{
		$lastinput[%a] = "";
		$outputeventset[%a] = 0;
		$targeteventset[%a] = 0;
		$rowused[%a] = 0;
	}

	$highestrow=0;
	$realhigh=0;
}

function getinputeventslist(%button)
{
	%button.clear();
	for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
		%button.addFront($InputEvent_NamefxDTSBrick_[%a],0);
	%button.sort();
	%button.addFront("_Custom_",0);
}


function getoutputeventslist(%button,%type)
{
	%button.clear();
	eval("for(%a=0;%a<$OutputEvent_Count"@%type@";%a++) %button.addFront($OutputEvent_Name"@%type@"_[%a],%a,0);");
	%button.sort();
	%button.addFront("_Custom_",0);
	
}

function targetuitoid(%row,%ui)
{
	if(%ui $= "Brick")
		return "fxDTSBrick";

	%event = $rowinputbutton[%row].getValue();
	%index = -1;
	for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
		if($InputEvent_NamefxDTSBrick_[%a] $= %event)
			%index = %a;
	%numf = getFieldCount($InputEvent_TargetListfxDTSBrick_[%index]);
	
	for(%a=0;%a<%numf;%a++)
		if(%ui $= getWord(getField($InputEvent_TargetListfxDTSBrick_[%index],%a),0))
			return getWord(getField($InputEvent_TargetListfxDTSBrick_[%index],%a),1);
}

function settargetbuttonrow(%row)
{
	%event = $rowinputbutton[%row].getValue();
	%index = -1;
	for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
		if($InputEvent_NamefxDTSBrick_[%a] $= %event)
			%index = %a;
	%numf = getFieldCount($InputEvent_TargetListfxDTSBrick_[%index]);
	$rowtargetbutton[%row].clear();
	for(%a=0; %a<%numf; %a++)
	{
		%name = getWord(getField($InputEvent_TargetListfxDTSBrick_[%index],%a),0);
		if(%name $= "Self")
			%name = "Brick";
		$rowtargetbutton[%row].addFront(%name,%a,0);
	}	
	$rowtargetbutton[%row].sort();
}

function NewEventsDlg::showeventcolormenu(%this,%obj,%row)
{
	if(isObject(Avatar_ColorMenu))
		Avatar_ColorMenu.delete();
	if(isObject(DDEventsColor))
		DDEventsColor.delete();
		
	WrenchEventsDlg::createColorMenu(%this.getObject(0),DummyColor);
		
	Avatar_ColorMenu.setName("DDEventsColor");

	NewEW.add(DDEventsColor);


	for(%i=0;%i<64;%i++)
	{
		%num = (%i*2)+1;
			
		if(%num >= DDEventsColor.getObject(0).getCount())
			break;
			
		%o = DDEventsColor.getObject(0).getObject(%num);
		%o.command = "pickeventColor(" @ %i @ "," @ %row @");";
	}

	DDEventsColor.position = "600 100";
}

function pickeventcolor(%color,%row)
{
	%a = DDEventsColor.getObject(0).getObject(%color*2);
	%row.color = %a.color;
	DDEventsColor.delete();
}

function inputeventshow(%row)
{
	NewEventScroll.scrolltotop();showallfeatures();

	$realhigh++;

	if($rowused[%row])
	{
		if(isObject($rowinputbutton[%row]))
			$rowinputbutton[%row].delete();
	}

	$rowused[%row] = true;
	addcolor(%row,0);

        $rowinputbutton[%row] = new GuiPopUpMenuCtrl() {
            profile = "GuiPopUpMenuProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "4 " SPC 6+(%row*30);
            extent = "110 18";
            minExtent = "8 2";
            visible = "1";
            maxLength = "255";
            maxPopupHeight = "200";
	    command = "checkforinputevents();";
        };

	NewEventScroll.add($rowinputbutton[%row]);
	getinputeventslist($rowinputbutton[%row]);

}

function opentargetevent(%row)
{
	NewEventScroll.scrolltotop();showallfeatures();
	
	if(isObject($rowtargetbutton[%row]))
		$rowtargetbutton[%row].delete();

	$targeteventset[%row] = true;
	$lasttarget[%row] = "";
        $rowtargetbutton[%row] = new GuiPopUpMenuCtrl() {
            profile = "GuiPopUpMenuProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "129 " SPC 6+(%row*30);
            extent = "110 18";
            minExtent = "8 2";
            visible = "1";
            maxLength = "255";
            maxPopupHeight = "200";
	    command = "checkfortargets();";
        };

	settargetbuttonrow(%row);
	NewEventScroll.add($rowtargetbutton[%row]);
}

function settlealllasts(%a)
{
	if(isObject($rowinputbutton[%a]))
		$lastinput[%a] = $rowinputbutton[%a].getValue();
	else
		$lastinput[%a] = "";
	if(isObject($rowtargetbutton[%a]))
		$lasttarget[%a] = $rowtargetbutton[%a].getValue();
	else
		$lasttarget[%a] = "";
	if(isObject($rowoutputevent[%a]))
		$lastoutputchosen[%a] = $rowoutputevent[%a].getValue();
	else
		$lastoutputchosen[%a] = "";
}

function reallyAllLasts()
{
	for(%a=0;%a<100;%a++)
		settlealllasts(%a);
}

function clearinputbox(%a)
{
						
							$rowinputbutton[%a].delete();
							$rowinputbutton[%a] = new GuiPopUpMenuCtrl() 
							{
            								profile = "GuiPopUpMenuProfile";
            								horizSizing = "right";
           								 vertSizing = "bottom";
            								position = "4 " SPC 6+(%a*30);
            								extent = "110 18";
            								minExtent = "8 2";
            								visible = "1";
            								maxLength = "255";
            								maxPopupHeight = "200";
	   					 		command = "checkforinputevents();";
       							 };

							NewEventScroll.add($rowinputbutton[%a]);
							getinputeventslist($rowinputbutton[%a]);

							$rowinputbutton[%a].setValue("");

							$lastinput[%a] = "";
							checkforinputevents();
}

function checkforinputevents()
{
	for(%a=0;%a<$highestrow+1;%a++)
	{
		if(isObject($rowinputbutton[%a]))
		{
			if(strlen($rowinputbutton[%a].getValue()) > 0)
			{
				if($lastinput[%a] !$= $rowinputbutton[%a].getValue())
				{
					if($rowinputbutton[%a].profile $= "GuiPopUpMenuProfile")
					{
					
						if($rowinputbutton[%a].getValue() $= "_Custom_")
						{
							$rowinputbutton[%a].delete();
							$rowinputbutton[%a] = new GuiTextEditCtrl()
							 {
            								profile = "GuiTextEditProfile";
           								horizSizing = "right";
            								vertSizing = "bottom";
             								position = "4 " SPC 6+(%a*30);
             								extent = "110 18";
             								minExtent = "8 2";
            								visible = "1";
             								maxLength = "255";
	     							command = "checkforinputevents();";
								accelerator = "return";
								escapeCommand = "clearinputbox("@%a@");";
         							};
							NewEventScroll.add($rowinputbutton[%a]);
						}
						else
						{
							$lastinput[%a] = $rowinputbutton[%a].getValue();
							opentargetevent(%a);
						}
					}
					else
					{
						$lastinput[%a] = $rowinputbutton[%a].getValue();

						%proceed = 0;
						for(%z=0;%z<$InputEvent_CountfxDTSBrick;%z++)
							if($InputEvent_NamefxDTSBrick_[%z] $= $rowinputbutton[%a].getValue())
								%proceed = 1;

						if(%proceed)
						{
							%value = $rowinputbutton[%a].getValue();
							$rowinputbutton[%a].delete();
							$rowinputbutton[%a] = new GuiPopUpMenuCtrl() 
							{
            								profile = "GuiPopUpMenuProfile";
            								horizSizing = "right";
           								 vertSizing = "bottom";
            								position = "4 " SPC 6+(%a*30);
            								extent = "110 18";
            								minExtent = "8 2";
            								visible = "1";
            								maxLength = "255";
            								maxPopupHeight = "200";
	   					 		command = "checkforinputevents();";
       							 };

							NewEventScroll.add($rowinputbutton[%a]);
							getinputeventslist($rowinputbutton[%a]);

							$rowinputbutton[%a].setValue(%value);

							$lastinput[%a] = "";
							checkforinputevents();
						}
					}
				}
			}
		}
	}
}

function openoutputevent(%row)
{
	NewEventScroll.scrolltotop();showallfeatures();

	if(isObject($rowdelaybox[%row]))
		$rowdelaybox[%row].delete();
	if(isObject($rowoutputevent[%row]))
		$rowoutputevent[%row].delete();

	$lastoutputchosen[%row] = -1;
	

	$outputeventset[%row] = true;

	$rowdelaybox[%row] = new GuiTextEditCtrl() {
            profile = "GuiTextEditProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "254 " @ 6+(%row*30);
            extent = "32 18";
            minExtent = "8 2";
            visible = "1";
            maxLength = "255";
            historySize = "0";
            password = "0";
            tabComplete = "0";
            sinkAllKeyEvents = "0";
         };

        $rowoutputevent[%row] = new GuiPopUpMenuCtrl() {
            profile = "GuiPopUpMenuProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "296 " SPC 6+(%row*30);
            extent = "110 18";
            minExtent = "8 2";
            visible = "1";
            maxLength = "255";
            maxPopupHeight = "200";
	    command = "checkforparams();";
        };

	NewEventScroll.add($rowdelaybox[%row]);
	NewEventScroll.add($rowoutputevent[%row]);
	NewEventScroll.pushToBack($rowoutputevent[%row]);
	NewEventScroll.pushToBack($rowdelaybox[%row]);
	getoutputeventslist($rowoutputevent[%row],targetuitoid(%row,$rowtargetbutton[%row].getValue()));
}

function datablocklistbutton(%button,%name)
{
	if(%name $= "Music")
		%name = "AudioProfile";

	%button.clear();

	if(DatablockGroup.getCount() > 2)
		%group = DatablockGroup;
	else
		%group = ServerConnection;
		
	for(%i=0;%i<%group.getCount();%i++)
	{
		%o = %group.getObject(%i);
		if(%o.getClassName() $= "AudioProfile" && %name $= "Sound")
		{
			if(%o.uiName $= "")
			{
				%usename = %o.fileName;
				if(strpos(%usename,"/") > 0)
				{
					%offset = strpos(%usename,"/");
					%lastoffset = 0;
					while(strpos(%usename,"/",%offset) > -1)
					{
						%lastoffset = %offset;
						%offset = strpos(%usename,"/",%offset+1);
					}
					%usename = getsubstr(%usename,%lastoffset+1,strlen(%usename)-(%lastoffset+1));
				}
				%button.add(%usename,%o.getID());
				%button.itemID[%usename] = %o.getID();
			}
		}
		else if(%o.getClassName() $= %name &&  %o.uiName !$= "" && %o.uiName !$= " ")
		{
			%button.add(%o.uiName,%o.getID());
			%button.itemID[%o.uiName] = %o.getID();
		}
		else if(%name $= "Vehicle" && %o.rideable &&  %o.uiName !$= "" && %o.uiName !$= " ")
		{
			%button.add(%o.uiName,%o.getID());
			%button.itemID[%o.uiName] = %o.getID();
		}
	}
	%button.add("_None",-1);
	%button.sort();	
}

function eventbricktoid(%name)
{
	%idcount = ServerConnection.NTNameCount;
	for(%a=0;%a<%idcount;%a++)
		if(ServerConnection.NTName[%a] $= %name)
			return %a;
	return -1;
}

function eventidtobrick(%id)
{
	return ServerConnection.NTName[%id];
}

function checkforparaform(%row)
{
	NewEventScroll.scrolltotop();
	showallfeatures();

	$rowparaspace[%row] = 0;

	%eventform = $rowoutputevent[%row];
	%eventname = %eventform.getValue();
	%targetform = $rowtargetbutton[%row];
	%targetname = targetuitoid(%row,%targetform.getValue());
	%eventid = -1;
	for(%a=0;%a<$OutputEvent_Count[%targetname];%a++)
		if($OutputEvent_Name[%targetname,%a] $= %eventname)
			%eventid = %a;
	%parameters = $OutputEvent_parameterList[%targetname,%eventid];
	%numparams = getFieldCount(%parameters);

	for(%a=0;%a<%numparams+10;%a++)
		if(isObject($rowparameter[%row,%a]))
			$rowparameter[%row,%a].delete();

		if(isObject($rownamebox[%row]))
			$rownamebox[%row].delete();

		if(%targetname $= "fxDTSBrick")
		{

		$rownamebox[%row] = new GuiTextEditCtrl() {
            		profile = "NewEvents_TextEditProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 458+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "82 18";
            		minExtent = "8 2";
            		visible = "1";
            		maxLength = "255";
            		historySize = "0";
            		password = "0";
            		tabComplete = "0";
		text = "self";
            		sinkAllKeyEvents = "0";
         		};
			NewEventScroll.add($rownamebox[%row]);
			NewEventScroll.pushToBack($rownamebox[%row]);
		$rowparaspace[%row] += 90;
		}

	for(%a=0;%a<%numparams;%a++)
	{
		%parameter = getField(%parameters,%a);
		%type = getWord(%parameter,0);
		if(%type $= "int")
		{
			$rowparameter[%row,%a] = new GuiTextEditCtrl() {
            		profile = "GuiTextEditProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 458+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "32 18";
            		minExtent = "8 2";
            		visible = "1";
            		maxLength = "255";
            		historySize = "0";
            		password = "0";
            		tabComplete = "0";
            		sinkAllKeyEvents = "0";
         		};
			
			$rowparaspace[%row]+=40;
		}
		if(%type $= "string" || %type $= "intList")
		{
			$rowparameter[%row,%a] = new GuiTextEditCtrl() {
            		profile = "GuiTextEditProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 467+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "82 18";
            		minExtent = "8 2";
            		visible = "1";
            		maxLength = "255";
            		historySize = "0";
            		password = "0";
            		tabComplete = "0";
            		sinkAllKeyEvents = "0";
         		};
			$rowparaspace[%row]+=99;
		}	
		if(%type $= "vector")
		{
			$rowparameter[%row,%a] = new GuiTextEditCtrl() {
            		profile = "GuiTextEditProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 462+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "82 18";
            		minExtent = "8 2";
            		visible = "1";
            		maxLength = "255";
            		historySize = "0";
            		password = "0";
            		tabComplete = "0";
            		sinkAllKeyEvents = "0";
         		};
			$rowparaspace[%row]+=95;
		}
		if(%type $= "bool")
		{
			$rowparameter[%row,%a] = new GuiCheckBoxCtrl() {
         		profile = "GuiCheckBoxProfile";
         		horizSizing = "right";
         		vertSizing = "bottom";
         		position = 460+$rowparaspace[%row] SPC 5+(%row*30);
         		extent = "20 20";
         		minExtent = "8 2";
         		visible = "1";
         		text = "";
         		groupNum = "-1";
         		buttonType = "ToggleButton";
      			};
			$rowparaspace[%row]+=16;
		}
		if(%type $= "float")
		{
			$rowparameter[%row,%a] = new GuiSliderCtrl() {
			profile = "GuiSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 460+$rowparaspace[%row] SPC 4+(%row*30);
			extent = "64 22";
			visible = true;
			range = getword(%parameter,1) SPC getword(%parameter,2);
			value = getword(%parameter,4);
			};
			$rowparaspace[%row] += 80;
		}
		if(%type $= "datablock")
		{
			$rowparameter[%row,%a] = new GuiPopUpMenuCtrl() {
            		profile = "GuiPopUpMenuProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 460+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "100 18";
            		minExtent = "8 2";
            		visible = "1";
            		maxLength = "255";
            		maxPopupHeight = "200";
        		};
			$rowparaspace[%row] += 110;

			datablocklistbutton($rowparameter[%row,%a],getword(%parameter,1));
		}	
		if(%type $= "list")
		{


		$rowparameter[%row,%a] = new GuiPopUpMenuCtrl() {
            		profile = "GuiPopUpMenuProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 460+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "100 18";
            		minExtent = "8 2";
            		visible = "1";
            		maxLength = "255";
            		maxPopupHeight = "200";
        		};

			NewEventScroll.add($rowparameter[%row,%a]);
			NewEventScroll.pushToBack($rowparameter[%row,%a]);

			$rowparaspace[%row] += 110;
			%listparam = getField(%parameters,%a);
			%words = getWordCount(%listparam);
			$rowparameter[%row,%a].clear();
			for(%v=1;%v<%words-1;%v+=2)
				$rowparameter[%row,%a].add(getWord(%listparam,%v),getWord(%listparam,%v+1));
		}
		if(%type $= "paintColor")
		{

			$rowparameter[%row,%a] = new GuiSwatchCtrl() {
            		profile = "GuiDefaultProfile";
            		horizSizing = "right";
            		vertSizing = "bottom";
            		position = 460+$rowparaspace[%row] SPC 6+(%row*30);
            		extent = "18 18";
            		minExtent = "1 1";
            		visible = "1";
		paintbox=1;
            		color = "255 255 255 255";
		};
		$rowparameter[%row,%a].paintbox=1;
			$aaa = new GuiBitmapButtonCtrl(){
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "18 18";
			visible = true;
			buttonType = "PushButton";
			bitmap = "base/client/ui/btnColor";
			mColor="0 0 0 255";
			text="";
			command = "NewEventsDlg.showeventcolormenu($aaa,"@$rowparameter[%row,%a] @");";
			
			
			};
			$rowparameter[%row,%a].add($aaa);

			$rowparaspace[%row]+=25;
		}	

		if(isObject($rowparameter[%row,%a]))
		{
			NewEventScroll.add($rowparameter[%row,%a]);
			NewEventScroll.pushToBack($rowparameter[%row,%a]);
		}
	}
}


function checkfortargets()
{
	for(%a=0;%a<$highestrow+1;%a++)
	{
		if(isObject($rowtargetbutton[%a]))
		{
			if($lasttarget[%a] !$= $rowtargetbutton[%a].getValue() && $lasttarget[%a] !$= targetuitoid(%a,$rowtargetbutton[%a].getValue()))
			{
				$lasttarget[%a] = $rowtargetbutton[%a].getValue();
				openoutputevent(%a);
				addcolor(%a,0);
			}
		}
	}
}

function showallfeatures()
{
		for(%a=0;%a<$highestrow+1;%a++)
		{
			if(isObject($rowinputbutton[%a]))
				NewEventScroll.pushToBack($rowinputbutton[%a]);
			if(isObject($rowtargetbutton[%a]))
				NewEventScroll.pushToBack($rowtargetbutton[%a]);
			if(isObject($rowdelaybox[%a]))
				NewEventScroll.pushToBack($rowdelaybox[%a]);
			if(isObject($rowoutputevent[%a]))
				NewEventScroll.pushToBack($rowoutputevent[%a]);
			if(isObject($rowcheckbox[%a]))
				NewEventScroll.pushToBack($rowcheckbox[%a]);
			if(isObject($rownamebox[%a]))
				NewEventScroll.pushToBack($rownamebox[%a]);
			if(isObject($rowremove[%a]))
				NewEventScroll.pushToBack($rowremove[%a]);
			if(isObject($rowcopy[%a]))
				NewEventScroll.pushToBack($rowcopy[%a]);
			for(%b=0;%b<10;%b++)
			{
				if(isObject($rowparameter[%a,%b]))
					NewEventScroll.pushToBack($rowparameter[%a,%b]);
			}
		}
}

function removeeventrow(%row)
{
		addcolor(%row,0);
		$rowinputbutton[%row].setValue("");
		if(isObject($rowtargetbutton[%row]))
			$rowtargetbutton[%row].delete();
		if(isObject($rowdelaybox[%row]))
			$rowdelaybox[%row].delete();
		if(isObject($rowoutputevent[%row]))
			$rowoutputevent[%row].delete();
		if(isObject($rowcheckbox[%row]))
			$rowcheckbox[%row].delete();
		if(isObject($rownamebox[%row]))
			$rownamebox[%row].delete();
		if(isObject($rowremove[%row]))
			$rowremove[%row].delete();
		if(isObject($rowcopy[%row]))
			$rowcopy[%row].delete();
		if(isObject($rownum[%row]))
			$rownum[%row].delete();
		if(isObject($rowup[%row]))
			$rowup[%row].delete();
		if(isObject($rowdown[%row]))
			$rowdown[%row].delete();
		for(%b=0;%b<10;%b++)
			if(isObject($rowparameter[%row,%b]))
				$rowparameter[%row,%b].delete();
		$outputeventset[%row] = 0;
		$targeteventset[%row] = 0;
		settlealllasts(%row);

		showallfeatures();
		eventrowalign();

}

function copyeventrow(%row)
{
	%newrow = $realhigh;
	settlealllasts(%newrow);
	inputeventshow(%newrow,0);	
	$rowinputbutton[%newrow].setValue($rowinputbutton[%row].getValue());
	opentargetevent(%newrow);	
	$rowtargetbutton[%newrow].setValue($rowtargetbutton[%row].getValue());
	openoutputevent(%newrow);
	$rowdelaybox[%newrow].setValue($rowdelaybox[%row].getValue());
	$rowoutputevent[%newrow].setValue($rowoutputevent[%row].getValue());
	addcolor(%newrow,1);
	checkforparams(1);
	if(isObject($rownamebox[%newrow]))
		$rownamebox[%newrow].setValue($rownamebox[%row].getValue());
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row,%a]))
		{
			if($rowparameter[%row,%a].paintbox)
				$rowparameter[%newrow,%a].color = $rowparameter[%row,%a].color;
			else
				$rowparameter[%newrow,%a].setValue($rowparameter[%row,%a].getValue());

			if($rowparameter[%row,%a].profile $= "GuiPopUpMenuProfile")
				$rowparameter[%newrow,%a].setSelected($rowparameter[%row,%a].getSelected());
		}
	}
	settlealllasts(%newrow);
	
}

function checkenabledevents()
{
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rowcheckbox[%a]))
			if($rowcheckbox[%a].getValue())
				addcolor(%a,1);
			else
				addcolor(%a,0);
	eventrowalign();
}

function getrealrow(%row)
{
	%ret = 0;
	for(%a=0;%a<%row;%a++)
		if(isObject($rowinputbutton[%a]) && isObject($rowtargetbutton[%a]) && isObject($rowoutputevent[%a]))
			%ret++;
	return %ret;
}

function eventrowalign()
{
	for(%a=0;%a<$highestrow+1;%a++)
		if(isObject($rownum[%a]))
			$rownum[%a].setText(getrealrow(%a));
}

function eventmovedown(%row)
{
	if(!isObject($rowinputbutton[%row+1]))
		return;
	if($rowinputbutton[%row+1].getValue() $= "" || $rowinputbutton[%row+1].getValue() $= " ")
		return;

	settlealllasts(%row);
	settlealllasts(%row+1);
	
	%replacedInput = $rowinputbutton[%row+1].getValue();
	%replacedTarget = $rowtargetbutton[%row+1].getValue();
	%replacedOutput = $rowoutputevent[%row+1].getValue();
	%replacedDelay = $rowdelaybox[%row+1].getValue();
	%replacedEnabled = $rowcheckbox[%row+1].getValue();
	%replacedName = "";
	if(isObject($rownamebox[%row+1]))
		%replacedName = $rownamebox[%row+1].getValue();	
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row+1,%a]))
		{
			if($rowparameter[%row+1,%a].paintbox)
				%replacedParam[%a] = $rowparameter[%row+1,%a].color;
			else
				%replacedParam[%a] = $rowparameter[%row+1,%a].getValue();

			if($rowparameter[%row+1,%a].profile $= "GuiPopUpMenuProfile")
				%replacedParam[%a] = $rowparameter[%row+1,%a].getSelected();
		}
	}

	removeeventrow(%row+1);
	inputeventshow(%row+1,0);
	$rowinputbutton[%row+1].setValue($rowinputbutton[%row].getValue());
	opentargetevent(%row+1);	
	$rowtargetbutton[%row+1].setValue($rowtargetbutton[%row].getValue());
	openoutputevent(%row+1);
	$rowdelaybox[%row+1].setValue($rowdelaybox[%row].getValue());
	$rowoutputevent[%row+1].setValue($rowoutputevent[%row].getValue());
	addcolor(%row+1,1);
	checkforparams(1);
	$rowcheckbox[%row+1].setValue($rowcheckbox[%row].getValue());
	if(isObject($rownamebox[%row+1]))
		$rownamebox[%row+1].setValue($rownamebox[%row].getValue());
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row,%a]))
		{
			if($rowparameter[%row,%a].paintbox)
				$rowparameter[%row+1,%a].color = $rowparameter[%row,%a].color;
			else
				$rowparameter[%row+1,%a].setValue($rowparameter[%row,%a].getValue());

			if($rowparameter[%row,%a].profile $= "GuiPopUpMenuProfile")
				$rowparameter[%row+1,%a].setSelected($rowparameter[%row,%a].getSelected());
		}
	}

	removeeventrow(%row);
	inputeventshow(%row,0);
	$rowinputbutton[%row].setValue(%replacedInput);
	opentargetevent(%row);
	$rowtargetbutton[%row].setValue(%replacedTarget);
	openoutputevent(%row);
	$rowdelaybox[%row].setValue(%replacedDelay);
	$rowoutputevent[%row].setValue(%replacedOutput);
	addcolor(%row,1);
	checkforparams(1);
	$rowcheckbox[%row].setValue(%replacedEnabled);
	if(isObject($rownamebox[%row]))
		$rownamebox[%row].setValue(%replacedName);
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row,%a]))
		{
			if($rowparameter[%row,%a].paintbox)
				$rowparameter[%row,%a].color = %replacedParam[%a];
			else
				$rowparameter[%row,%a].setValue(%replacedParam[%a]);

			if($rowparameter[%row,%a].profile $= "GuiPopUpMenuProfile")
				$rowparameter[%row,%a].setSelected(%replacedParam[%a]);
		}
	}
	checkenabledevents();
	resetEventNumbers();
}

function eventmoveup(%row)
{
	if(%row == 0)
		return;

	settlealllasts(%row);
	settlealllasts(%row-1);
	
	%replacedInput = $rowinputbutton[%row-1].getValue();
	%replacedTarget = $rowtargetbutton[%row-1].getValue();
	%replacedOutput = $rowoutputevent[%row-1].getValue();
	%replacedDelay = $rowdelaybox[%row-1].getValue();
	%replacedEnabled = $rowcheckbox[%row-1].getValue();
	%replacedName = "";
	if(isObject($rownamebox[%row-1]))
		%replacedName = $rownamebox[%row-1].getValue();	
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row-1,%a]))
		{
			if($rowparameter[%row-1,%a].paintbox)
				%replacedParam[%a] = $rowparameter[%row-1,%a].color;
			else
				%replacedParam[%a] = $rowparameter[%row-1,%a].getValue();

			if($rowparameter[%row-1,%a].profile $= "GuiPopUpMenuProfile")
				%replacedParam[%a] = $rowparameter[%row-1,%a].getSelected();
		}
	}

	removeeventrow(%row-1);
	inputeventshow(%row-1,0);
	$rowinputbutton[%row-1].setValue($rowinputbutton[%row].getValue());
	opentargetevent(%row-1);	
	$rowtargetbutton[%row-1].setValue($rowtargetbutton[%row].getValue());
	openoutputevent(%row-1);
	$rowdelaybox[%row-1].setValue($rowdelaybox[%row].getValue());
	$rowoutputevent[%row-1].setValue($rowoutputevent[%row].getValue());
	addcolor(%row-1,1);
	checkforparams(1);
	$rowcheckbox[%row-1].setValue($rowcheckbox[%row].getValue());
	if(isObject($rownamebox[%row-1]))
		$rownamebox[%row-1].setValue($rownamebox[%row].getValue());
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row,%a]))
		{
			if($rowparameter[%row,%a].paintbox)
				$rowparameter[%row-1,%a].color = $rowparameter[%row,%a].color;
			else
				$rowparameter[%row-1,%a].setValue($rowparameter[%row,%a].getValue());

			if($rowparameter[%row,%a].profile $= "GuiPopUpMenuProfile")
				$rowparameter[%row-1,%a].setSelected($rowparameter[%row,%a].getSelected());
		}
	}

	removeeventrow(%row);
	inputeventshow(%row,0);
	$rowinputbutton[%row].setValue(%replacedInput);
	opentargetevent(%row);
	$rowtargetbutton[%row].setValue(%replacedTarget);
	openoutputevent(%row);
	$rowdelaybox[%row].setValue(%replacedDelay);
	$rowoutputevent[%row].setValue(%replacedOutput);
	addcolor(%row,1);
	checkforparams(1);
	$rowcheckbox[%row].setValue(%replacedEnabled);
	if(isObject($rownamebox[%row]))
		$rownamebox[%row].setValue(%replacedName);
	for(%a=0;%a<10;%a++)
	{
		if(isObject($rowparameter[%row,%a]))
		{
			if($rowparameter[%row,%a].paintbox)
				$rowparameter[%row,%a].color = %replacedParam[%a];
			else
				$rowparameter[%row,%a].setValue(%replacedParam[%a]);

			if($rowparameter[%row,%a].profile $= "GuiPopUpMenuProfile")
				$rowparameter[%row,%a].setSelected(%replacedParam[%a]);
		}
	}
	checkenabledevents();
	resetEventNumbers();
}

function resetEventNumbers()
{
	for(%a=0;%a<$highestrow+1;%a++)
	{
		if(isObject($rownum[%a]))
			$rownum[%a].setValue(%a);
	}
}

function checkboxcheck(%row)
{
	NewEventScroll.scrolltotop();
	showallfeatures();

	if(isObject($rownum[%row]))
		$rownum[%row].delete();

	$rownum[%row] = new GuiTextCtrl(){
	profile = "GuiTextProfile";
	position = "429" SPC (%row*30);
	extent = "8 18";
	minextent = "8 2";
	visible = true;
	text = getrealrow(%row);
	};
	
	

	if(isObject($rowremove[%row]))
		$rowremove[%row].delete();
	
	$rowremove[%row] = new GuiBitmapButtonCtrl(){
	profile = "BlockButtonProfile";
	horizSizing = "right";
	vertSizing = "top";
	position = "414 " @ (%row*30)+16;
	extent = "12 12";
	visible = true;
	mColor = "255 0 0 255";
	bitmap = "base/client/ui/button2";
	text = "X";
	command = "removeeventrow("@%row@");";
	};

	if(isObject($rowcopy[%row]))
		$rowcopy[%row].delete();
	
	$rowcopy[%row] = new GuiBitmapButtonCtrl(){
	profile = "BlockButtonProfile";
	horizSizing = "right";
	vertSizing = "top";
	position = "427 " @ (%row*30)+16;
	extent = "12 12";
	visible = true;
	mColor = "0 0 255 255";
	bitmap = "base/client/ui/button2";
	text = "X";
	command = "copyeventrow("@%row@");";
	};

	if(isObject($rowcheckbox[%row]))
		$rowcheckbox[%row].delete();

	$rowcheckbox[%row] = new GuiCheckBoxCtrl() {
         profile = "GuiCheckBoxProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "414" SPC (%row*30)-2;
         extent = "13 21";
         minExtent = "8 2";
         visible = "1";
         text = "";
         groupNum = "-1";
	 command = "checkenabledevents();";
         buttonType = "ToggleButton";
      };

	$rowdown[%row] = new GuiBitmapButtonCtrl()
	{
	profile = "BlockButtonProfile";
	horizSizing = "right";
	vertSizing = "top";
	position = "441 " @ (%row*30)+16;
	extent = "12 12";
	visible = true;
	mColor = "200 200 200 255";
	bitmap = "base/client/ui/button2";
	text = "X";
	command = "eventmovedown("@%row@");";
	};

	$rowup[%row] = new GuiBitmapButtonCtrl()
	{
	profile = "BlockButtonProfile";
	horizSizing = "right";
	vertSizing = "top";
	position = "441 " @ (%row*30)+2;
	extent = "12 12";
	visible = true;
	mColor = "200 200 200 255";
	bitmap = "base/client/ui/button2";
	text = "X";
	command = "eventmoveup("@%row@");";
	};

	NewEventScroll.add($rowcheckbox[%row]);
	NewEventScroll.pushToBack($rowcheckbox[%row]);
	NewEventScroll.add($rownum[%row]);
	NewEventScroll.pushToBack($rownum[%row]);
	NewEventScroll.add($rowremove[%row]);
	NewEventScroll.pushToBack($rowremove[%row]);
	NewEventScroll.add($rowcopy[%row]);
	NewEventScroll.pushToBack($rowcopy[%row]);
	NewEventScroll.add($rowdown[%row]);
	NewEventScroll.pushToBack($rowdown[%row]);
	NewEventScroll.add($rowup[%row]);
	NewEventScroll.pushToBack($rowup[%row]);

	$rowcheckbox[%row].setValue(1);	
}

function outputboxclear(%a)
{
							$rowoutputevent[%a].delete();
							$rowoutputevent[%a] = new GuiPopUpMenuCtrl() 
							{
            								 profile = "GuiPopUpMenuProfile";
           								horizSizing = "right";
            								vertSizing = "bottom";
            								position = "296 " SPC 6+(%a*30);
            								 extent = "110 18";
            								minExtent = "8 2";
            								visible = "1";
            								maxLength = "255";
            								maxPopupHeight = "200";
	   					 		command = "checkforparams();";
       							 };

							NewEventScroll.add($rowoutputevent[%a]);
							getoutputeventslist($rowoutputevent[%a],targetuitoid(%a,$rowtargetbutton[%a].getValue()));
							$rowoutputevent[%a].setValue("");

							$lastoutputchosen[%a] = "";
}

function checkforparams(%nonewrow)
{
	for(%a=0;%a<$highestrow+1;%a++)
	{
		if(isObject($rowoutputevent[%a]))
		{
			if(strlen($rowoutputevent[%a].getValue()) > 0)
			{
				if($rowoutputevent[%a].getValue() !$= $lastoutputchosen[%a])
				{
					if($rowoutputevent[%a].profile $= "GuiPopUpMenuProfile")
					{
						if($rowoutputevent[%a].getValue() $= "_Custom_")
						{
							$rowoutputevent[%a].delete();
							$rowoutputevent[%a] = new GuiTextEditCtrl()
							 {
            								            profile = "GuiTextEditProfile";
           									 horizSizing = "right";
            									 vertSizing = "bottom";
            									 position = "296 " SPC 6+(%a*30);
            									 extent = "110 18";
            									 minExtent = "8 2";
            									 visible = "1";
            									 maxLength = "255";
            									 maxPopupHeight = "200";
	     							command = "checkforparams();";
								accelerator = "return";
								escapeCommand = "outputboxclear("@%a@");";
         							};
							NewEventScroll.add($rowoutputevent[%a]);
						}
						else
						{
							$lastoutputchosen[%a] = $rowoutputevent[%a].getValue();
							if(%a == $highestrow && !%nonewrow)
								inputeventshow($highestrow+1,0);
							addcolor(%a,1);
							checkboxcheck(%a);
							checkforparaform(%a);
						}
					}
					else
					{
						$lastoutputchosen[%a] = $rowoutputevent[%a].getValue();

						%proceed = 0;
						eval("for(%z=0;%z<$OutputEvent_Count"@targetuitoid(%a,$rowtargetbutton[%a].getValue())@";%z++)if($OutputEvent_Name"@targetuitoid(%a,$rowtargetbutton[%a].getValue())@"_[%z]$=$rowoutputevent["@%a@"].getValue())%proceed=1;");

						if(%proceed)
						{
							%value = $rowoutputevent[%a].getValue();
							$rowoutputevent[%a].delete();
							$rowoutputevent[%a] = new GuiPopUpMenuCtrl() 
							{
            								 profile = "GuiPopUpMenuProfile";
           								horizSizing = "right";
            								vertSizing = "bottom";
            								position = "296 " SPC 6+(%a*30);
            								 extent = "110 18";
            								minExtent = "8 2";
            								visible = "1";
            								maxLength = "255";
            								maxPopupHeight = "200";
	   					 		command = "checkforparams();";
       							 };

							NewEventScroll.add($rowoutputevent[%a]);
							getoutputeventslist($rowoutputevent[%a],targetuitoid(%a,$rowtargetbutton[%a].getValue()));
							$rowoutputevent[%a].setValue(%value);

							$lastoutputchosen[%a] = "";
							checkforparams();
						}
					}
				}
			}
		}
	}
}

function inputwithrh()
{
	inputeventshow($realhigh);
}

function newEventsDlg::onWake(%this)
{
	$settingfavorite = 0;
	eventsetbutton.mColor = "255 255 255 255";
	if(NewCopyButton.getValue() == 0)
	{
		clearcolorrows();
		commandtoserver('RequestEventTables');
		schedule(500,0,inputwithrh);
	}
}

function eventrefresh()
{
	sendevents();
	clearcolorrows();
	newEventsDlg::onWake(%this);
}

function eventclear()
{
	clearcolorrows();
	schedule(500,0,inputwithrh);
}

function wrenchwindowreplace()
{
	Wrench_Window.getObject(38).command = "canvas.pushDialog(NewEventsDlg);";
	wrenchBot_Window.getObject(38).command = "canvas.pushDialog(NewEventsDlg);";
	WrenchVehicleSpawn_Window.getObject(18).command = "canvas.pushDialog(NewEventsDlg);";
	WrenchSound_Window.getObject(9).command = "canvas.pushDialog(NewEventsDlg);";

	$switchbutton = new GuiBitmapButtonCtrl()
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "640 549";
		extent = "60 38";
		visible = true;
		command = "neweventwindow();";
		text = "GUI Swap";
		bitmap = "base/client/ui/button2";
		mColor = "255 255 0 255";
		buttonType = "PushButton";
      	};

	WrenchEvents_Window.add($switchbutton);
}
schedule(10000,0,wrenchwindowreplace);

function determinebestColor(%target)
{
	%best = 1000;
	%bestcolor = 0;
	for(%i = 0; %i < 64; %i++) //Loop 64 times (Aka through the whole colorset)
	{
		%colori = vectorScale(getColorIdTable(%i),255); //Find the values of the 64 colors
		%dist = vectorDist(%colori, %target); //Find the distance between the goal and the found values
		//echo(%target @ "|" @ %colori @ "|" @ %dist);
		if(%dist < %best) //If a better color is found...
		{
			%best = %dist; //... make that color the new best color
			%bestcolor = %i;
		}
	}
	return %bestcolor;
}

package neweventdialog
{
	function clientCmdAddEvent(%a,%b)
	{
		%enabled = getField(%a,0);
		%input = getField(%a,1);
		%wait = getField(%a,2);
		%target = getField(%a,3);
		%name = getField(%a,4);
		%output = getField(%a,5);
		%arg[0] = getField(%a,6);
		%arg[1] = getField(%a,7);
		%arg[2] = getField(%a,8);
		%arg[3] = getField(%a,9);
		%arg[4] = getField(%a,10);
		%arg[5] = getField(%a,11);
		%arg[6] = getField(%a,12);
		
		
			%row = $realhigh;
			inputeventshow(%row,0);
			$rowinputbutton[%row].setValue($InputEvent_NamefxDTSBrick_[%input]);
			opentargetevent(%row);
			if(strlen(getWord(getField($InputEvent_TargetListfxDTSBrick_[%input],%target),1)) < 1)
				$rowtargetbutton[%row].setValue("Brick");
			else
				$rowtargetbutton[%row].setValue(getWord(getField($InputEvent_TargetListfxDTSBrick_[%input],%target),0));
			if($rowtargetbutton[%row].getValue() $= "Self")
				$rowtargetbutton[%row].setValue("Brick");
			openoutputevent(%row);

			if(%row > 0)
			{
				NewEventScroll.pushToBack($rowoutputevent[%row-1]);
				NewEventScroll.pushToBack($rowdelaybox[%row-1]);
			}
			$rowdelaybox[%row].setValue(%wait);
			eval("%outputname = $OutputEvent_Name"@targetuitoid(%row,$rowtargetbutton[%row].getValue())@"_["@%output@"];");
			$rowoutputevent[%row].setValue(%outputname);
			addcolor(%row,1);
			checkforparaform(%row);


			for(%a=0;%a<10;%a++)
			{
				if(strlen(%arg[%a])>0 && isObject($rowparameter[%row,%a]))
				{
					if($rowparameter[%row,%a].paintbox)
					{
						%tc = getColorIDTable(%arg[%a]);
						%tc = vectorScale(%tc,255);
						$rowparameter[%row,%a].color = %tc;
					}
					else if($rowparameter[%row,%a].profile $= "GuiPopUpMenuProfile")
						$rowparameter[%row,%a].setSelected(%arg[%a]);
					else
						$rowparameter[%row,%a].setValue(%arg[%a]);
				}
			}
			$lasttarget[%row] = targetuitoid(%row,$rowtargetbutton[%row].getValue());

			if(%target == -1)
			{
				%name = eventidtobrick(%name);
				if(getSubStr(%name,0,1) $= "_")
					%name = getSubStr(%name,1,strlen(%name)-1);
				$rownamebox[%row].setValue(%name);
			}

		checkboxcheck(%row);
		if(%enabled)
			$rowcheckbox[%row].setValue(1);
		else
		{
			$rowcheckbox[%row].setValue(0);
			addcolor(%row,0);
		}

		settlealllasts(%row);
	}
};
activatepackage(neweventdialog);

function sendEvents()
{
	commandtoserver('ClearEvents');
	for(%v=0;%v<$realhigh+1;%v++)
	{
		if(isObject($rowinputbutton[%v]) && isObject($rowtargetbutton[%v]) && isObject($rowoutputevent[%v]))
		{
			%targetbutton = $rowtargetbutton[%v];
			%outbutton = $rowoutputevent[%v];
			%targetname = targetuitoid(%v,%targetbutton.getValue());
			%delay = $rowdelaybox[%v].getValue();	

			if(%targetname !$= "fxDTSBrick")
			{
			%event = $rowinputbutton[%v].getValue();
			%index = -1;
			for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
				if($InputEvent_NamefxDTSBrick_[%a] $= %event)
					%index = %a;

			%targetidx = -1;
			for(%a=0; %a<getFieldCount($InputEvent_TargetListfxDTSBrick_[%index]); %a++)
			{
				if(%targetbutton.getValue() $= getWord(getField($InputEvent_TargetListfxDTSBrick_[%index],%a),0))
					%targetidx = %a;
			} 
		
			%event = %outbutton.getValue();
			%outindex = -1;
			for(%a=0;%a<$OutputEvent_Count[%targetname];%a++)
				if($OutputEvent_Name[%targetname,%a] $= %event)
					%outindex = %a;

			%param[0] = 0;
			for(%a=0;%a<10;%a++)
				if(isObject($rowparameter[%v,%a]))
				{
					if($rowparameter[%v,%a].paintbox)
						%param[%a] = determinebestColor($rowparameter[%v,%a].color);
					else if($rowparameter[%v,%a].profile $= "GuiPopUpMenuProfile")
						%param[%a] = $rowparameter[%v,%a].getSelected();
					else
						%param[%a] = $rowparameter[%v,%a].getValue();
				}
			commandtoserver('AddEvent',$rowcheckbox[%v].getValue(),%index,%delay,%targetidx,"",%outindex,%param[0],%param[1],%param[2],%param[3],%param[4],%param[5],%param[6],%param[7],%param[8],%param[9]);

			}
			else
			{
		
			%targets = getWordCount($rownamebox[%v].getValue());
			
			for(%i=0;%i<%targets;%i++)
			{
			%name = getWord($rownamebox[%v].getValue(),%i);
			if(%name !$= "" && %name !$= "self")
				%name = "_" @ %name;

			%event = $rowinputbutton[%v].getValue();
			%index = -1;
			for(%a=0;%a<$InputEvent_CountfxDTSBrick;%a++)
				if($InputEvent_NamefxDTSBrick_[%a] $= %event)
					%index = %a;

			%targetidx = -1;
			if(%name $= "" || %name $= "self")
				%targetidx = 0;
		
			%event = %outbutton.getValue();
			%outindex = -1;
			for(%a=0;%a<$OutputEvent_Count[%targetname];%a++)
				if($OutputEvent_Name[%targetname,%a] $= %event)
					%outindex = %a;

			%param[0] = 0;
			for(%a=0;%a<10;%a++)
				if(isObject($rowparameter[%v,%a]))
				{
					if($rowparameter[%v,%a].paintbox)
						%param[%a] = determinebestColor($rowparameter[%v,%a].color);
					else if($rowparameter[%v,%a].profile $= "GuiPopUpMenuProfile")
						%param[%a] = $rowparameter[%v,%a].getSelected();
					else
						%param[%a] = $rowparameter[%v,%a].getValue();
				}
			commandtoserver('AddEvent',$rowcheckbox[%v].getValue(),%index,%delay,%targetidx,eventbricktoid(%name),%outindex,%param[0],%param[1],%param[2],%param[3],%param[4],%param[5],%param[6],%param[7],%param[8],%param[9]);
			}
			}
		}
	}
}

function NewEventsSend()
{
	sendEvents();
	canvas.popDialog(newEventsDlg);
}

$settingfavorite = 0;

function eventsdlgfavset()
{
	$settingfavorite = !$settingfavorite;
	if($settingfavorite)
		eventsetbutton.mColor = "255 255 100 255";
	else
		eventsetbutton.mColor = "255 255 255 255";
}

function eventsdlgfavorite(%save)
{
	if($settingfavorite)
	{
		eventsetfavorite(%save);
		$settingfavorite = 0;
		eventsetbutton.mColor = "255 255 255 255";
	}
	else
		eventloadfavorite(%save);
}

function eventsetfavorite(%save)
{
	$newevent::highestrow[%save] = $highestrow;
	for(%a=0;%a<$highestrow+1;%a++)
	{
		if(isObject($rowinputbutton[%a]) && isObject($rowtargetbutton[%a]) && isObject($rowoutputevent[%a]))
		{
			$newevent::enabled[%save,%a] = $rowcheckbox[%a].getValue();
			$newevent::inputevent[%save,%a] = $rowinputbutton[%a].getValue();
			$newevent::target[%save,%a] = targetuitoid(%a,$rowtargetbutton[%a].getValue());
			$newevent::outputevent[%save,%a] = $rowoutputevent[%a].getValue();
			$newevent::delay[%save,%a] = $rowdelaybox[%a].getValue();
			$newevent::name[%save,%a] = "";
			if(isObject($rownamebox[%a]))
				$newevent::name[%save,%a] = $rownamebox[%a].getValue();
			for(%b=0;%b<10;%b++)
				if(isObject($rowparameter[%a,%b]))
					$newevent::param[%save,%a,%b]=$rowparameter[%a,%b].getValue();
				else
					$newevent::param[%save,%a,%b]="";
		}
	}
	export("$newevent::*","config/client/eventfavs.cs");
}

function eventloadfavorite(%save)
{
	clearcolorrows();
	for(%a=0;%a<$newevent::highestrow[%save];%a++)
	{
		%row = $realhigh;
		inputeventshow(%row,0);
		$rowinputbutton[%row].setValue($newevent::inputevent[%save,%a]);
		opentargetevent(%row);
		$rowtargetbutton[%row].setValue($newevent::target[%save,%a]);
		openoutputevent(%row);
		checkboxcheck(%row);
		$rowdelaybox[%row].setValue($newevent::delay[%save,%a]);
		$rowoutputevent[%row].setValue($newevent::outputevent[%save,%a]);
		checkforparaform(%row);
		if($newevent::enabled[%save,%a])
		{
			$rowcheckbox[%row].setValue(1);
			addcolor(%row,1);
		}
		else
		{
			$rowcheckbox[%row].setValue(0);
			addcolor(%row,0);
		}
		for(%b=0;%b<10;%b++)
		{
			if(isObject($rowparameter[%a,%b]))
				$rowparameter[%a,%b].setValue($newevent::param[%save,%a,%b]);
		}
		settlealllasts(%a);
	}
	inputeventshow($realhigh);
}

function defaulteventwindow()
{
	deactivatepackage(neweventdialog);
	Wrench_Window.getObject(38).command = "canvas.pushDialog(wrenchEventsDlg);";
	WrenchVehicleSpawn_Window.getObject(18).command = "canvas.pushDialog(wrenchEventsDlg);";
	WrenchSound_Window.getObject(9).command = "canvas.pushDialog(wrenchEventsDlg);";	
}

function neweventwindow()
{
	activatepackage(neweventdialog);
	wrenchwindowreplace();	
}

function NewEventsApplyDelay(%startline,%endline,%startvalue,%increment)
{
	%endline++;
	%rowstogotostart = %startline;
	%rowsmade = 0;

	for(%a=0;%a<100;%a++)
	{
		if(%rowstogotostart > 0)
		{
			if($rowused[%a] && isObject($rowdelaybox[%a]))
				%rowstogotostart--;
		}
		else
		{
			if(%startline+%rowsmade < %endline)
			{
				if($rowused[%a] && isObject($rowdelaybox[%a]))
				{
					$rowdelaybox[%a].setValue((%rowsmade*%increment)+%startvalue);
					%rowsmade++;
				}
			}
		}
	}
}

function neweventsbarmove()
{
	for(%a=0;%a<NewEW.getCount();%a++)
	{
		%obj = NewEW.getObject(%a);
		if(%obj.getClassName() $= "GuiSwatchCtrl")
		{
			if(getWord(%obj.extent,0) $= "1")
			{
					NewEventScroll.add(%obj);
					%obj.extent = "1 2000";
					%obj.minExtent = "1 2000";
					%obj.position = getword(%obj.position,0) - 30 SPC getword(%obj.position,1) - 60;
			}
		}
	}
}

neweventsbarmove();

function reloadne(){exec("add-ons/client_newevents/client.cs");}


		